﻿/*==============================================================================
 * Author:深度训练
 * Create time: 2013-08-10
 * Blog Address:http://www.cnblogs.com/wangiqngpei557/
 * Author Description:特定领域软件工程实践；
 *==============================================================================*/

namespace ConsoleApplication1
{
    using System;
    using ProgramComponent;
    using ProgramComponent.LanguageComponent;

    [Serializable]
    public class OrderCheckFlows : LanguageComponent
    {
        private ProgramBookmarkManager BookmarkManager = new ProgramBookmarkManager();

        public OrderCheckFlows(ProgramBookmarkManager bookmarkManager)
        {
            this.BookmarkManager = bookmarkManager;
            BookmarkManager.Add(new ProgramBookmark("checkPrices", new ProgramBookmarkLocation(CheckOrderPrices)));
        }
        public override void Run(ProgramBookmarkManager mgr)
        {
            this.BookmarkManager = mgr;
            StartCheck();
        }
        public void StartCheck()
        {
            BookmarkManager.Resume("checkPrices", null);
        }

        #region business flows
        public void CheckOrderPrices(ProgramComponent.ProgramBookmark nextCheck)
        {
            Console.WriteLine("checkPrices...");
            BookmarkManager.Remove(nextCheck);

            BookmarkManager.Add(new ProgramBookmark("checkItems", new ProgramBookmarkLocation(CheckOrderItems)));
            BookmarkManager.Resume("checkItems", true);
        }

        public void CheckOrderItems(ProgramComponent.ProgramBookmark nextCheck)
        {
            if ((bool)nextCheck.Payload)
                Console.WriteLine("checkItems...");
            else
                Console.WriteLine("end check items.");

            BookmarkManager.Remove(nextCheck);
        }
        #endregion
    }

    [Serializable]
    public class OrderSubmitFlows : LanguageComponent
    {
        private ProgramBookmarkManager BookmarkManager = new ProgramBookmarkManager();

        public OrderSubmitFlows(ProgramBookmarkManager bookmarkManager)
        {
            this.BookmarkManager = bookmarkManager;
            BookmarkManager.Add(new ProgramBookmark("CheckSubmitPrices", new ProgramBookmarkLocation(CheckSubmitPrices)));
        }

        public override void Run(ProgramBookmarkManager mgr)
        {
            this.BookmarkManager = mgr;
            StartCheck();
        }
        public void StartCheck()
        {
            BookmarkManager.Resume("CheckSubmitPrices", null);
        }

        #region business flows
        public void CheckSubmitPrices(ProgramComponent.ProgramBookmark nextCheck)
        {
            Console.WriteLine("CheckSubmitPrices...");
            BookmarkManager.Remove(nextCheck);

            BookmarkManager.Add(new ProgramBookmark("CheckSubmitItems", new ProgramBookmarkLocation(CheckSubmitItems)));
            BookmarkManager.Resume("CheckSubmitItems", true);
        }

        public void CheckSubmitItems(ProgramComponent.ProgramBookmark nextCheck)
        {
            if ((bool)nextCheck.Payload)
                Console.WriteLine("CheckSubmitItems...");
            else
                Console.WriteLine("end check CheckSubmitItems.");

            BookmarkManager.Remove(nextCheck);
        }
        #endregion
    }
}
