﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication1
{
    using ProgramComponent;
    using ProgramComponent.LanguageComponent;

    class Program
    {
        static void Main(string[] args)
        {
            ProgramBookmarkManager bookmarkManager = new ProgramBookmarkManager();

            OrderCheckFlows orderCheckFlow = new OrderCheckFlows(bookmarkManager);
            OrderSubmitFlows submitCheckFlow = new OrderSubmitFlows(bookmarkManager);

            IfElseLanguageComponent languageComponent = new IfElseLanguageComponent();
            languageComponent.Exp = () => { return false; };
            languageComponent.AddLangugateComponent(orderCheckFlow);
            languageComponent.AddLangugateComponent(submitCheckFlow);
            languageComponent.Run(bookmarkManager);

            Console.ReadLine();
        }
    }
}
