﻿/*==============================================================================
 * Author:深度训练
 * Create time: 2013-08-10
 * Blog Address:http://www.cnblogs.com/wangiqngpei557/
 * Author Description:特定领域软件工程实践；
 *==============================================================================*/

namespace ProgramComponent
{
    using System;

    /// <summary>
    /// Program book mark.
    /// </summary>
    [Serializable]
    public class ProgramBookmark
    {
        /// <summary>
        /// Mark program book mark.
        /// </summary>
        /// <param name="name">Mark name.</param>
        /// <param name="continueAt">Program continue.</param>
        public ProgramBookmark(string name, ProgramBookmarkLocation continueAt)
        {
            this.markname = name;
            this.continueAt = continueAt;
        }

        private string markname;
        /// <summary>
        /// Book mark name.
        /// </summary>
        public string BookmarkName { get { return markname; } }

        private ProgramBookmarkLocation continueAt;
        /// <summary>
        /// Continue location.
        /// </summary>
        public ProgramBookmarkLocation ContinueAt { get { return continueAt; } }

        /// <summary>
        /// Program load data.
        /// </summary>
        public object Payload { get; set; }
    }
    /// <summary>
    /// Program book mark location.
    /// </summary>
    /// <param name="resumed">Resumed bookmark.</param>
    public delegate void ProgramBookmarkLocation(ProgramBookmark resumed);
}
