﻿/*==============================================================================
 * Author:深度训练
 * Create time: 2013-08-10
 * Blog Address:http://www.cnblogs.com/wangiqngpei557/
 * Author Description:特定领域软件工程实践；
 *==============================================================================*/


namespace ProgramComponent
{
    using System.Collections.Generic;

    /// <summary>
    /// Program book mark Manager.<see cref="System.Collections.Dictionary{BookmarkName,ProgramBookmark}"/>
    /// </summary>
    public class ProgramBookmarkManager : Dictionary<string, ProgramBookmark>
    {
        /// <summary>
        /// Add programbookmark and instant next programbookmark.
        /// </summary>
        /// <param name="bookmark"><see cref="ProgramComponent.ProgramBookmark"/></param>
        public void Add(ProgramBookmark bookmark)
        {
            base.Add(bookmark.BookmarkName, bookmark);
        }
        /// <summary>
        /// Remove programbookmark.
        /// </summary>
        /// <param name="bookmark"><see cref="ProgramComponent.ProgramBookmark"/></param>
        public void Remove(ProgramBookmark bookmark)
        {
            base.Remove(bookmark.BookmarkName);
        }
        /// <summary>
        /// Resume  bookmark by bookmarkname.
        /// </summary>
        /// <param name="bookmarkName">bookmark name.</param>
        /// <param name="payload">Continue load.</param>
        public void Resume(string bookmarkName, object payload)
        {
            ProgramBookmark bookmark;
            this.TryGetValue(bookmarkName, out bookmark);
            if (bookmark != null)
            {
                bookmark.Payload = payload;
                bookmark.ContinueAt(bookmark);
            }
        }
    }
}
